## pgi 0.9.6.3

=== Makefile ===
# $Progeny: Makefile,v 1.176 2002/04/23 22:32:42 branden Exp $

SHELL=	/bin/sh -e
# XXX: make this configurable at some point

prefix?=	/usr
exec_prefix?=	${prefix}
bindir?=	${exec_prefix}/bin
mandir?=	${datadir}/man
datadir?=	${prefix}/share

ifndef OPTIONS_FILE_SOURCED

# for install-pgi rule (package building) only; otherwise this is set in the options file
ARCH=	$(shell dpkg --print-architecture)
ETC_DIR=/etc/pgi/custom
PGI_DIR=${prefix}/share/pgi

all:
	@echo "You must source $(ETC_DIR)/options in your shell before proceeding." >&2
	@echo "If you are not using the pgi-build command, you probably should be." >&2
	@exit 1
else

ifdef INSTALLER_ONLY
ARCHIVE=
else
ARCHIVE=archive
endif

ifdef DEBIAN_DEBOOTSTRAP
DEBOOTSTRAP_BUILD_DIR=
DEBOOTSTRAP_INSTALL_DIR=
DEBOOTSTRAP_RULE=
else
DEBOOTSTRAP_SOURCE_DIR=debootstrap
DEBOOTSTRAP_BUILD_DIR=${TDIR}/debootstrap-source
DEBOOTSTRAP_INSTALL_DIR=${TDIR}/debootstrap
DEBOOTSTRAP_RULE=${TDIR}/debootstrap-stamp
export DEBOOTSTRAP_INSTALL_DIR
endif

SUBDIR=		stage0 stage1 images/${ARCH} ${ARCHIVE}

all: ${DEBOOTSTRAP_RULE} _all_recursive

_all_recursive:
	@for dir in ${SUBDIR}; do					\
		${MAKE} -C $$dir "_THISDIR_=$${dir}/";			\
	done

# Run make clean in all subdirs with a Makefile
clean distclean:
	@for dir in ${SUBDIR}; do					\
		${MAKE} -C $$dir "_THISDIR_=$${dir}/" $@;		\
	done
ifdef DEBOOTSTRAP_SOURCE_DIR
	rm -rf ${DEBOOTSTRAP_BUILD_DIR} ${DEBOOTSTRAP_INSTALL_DIR}
	rm -f ${DEBOOTSTRAP_RULE}
endif

ifdef DEBOOTSTRAP_SOURCE_DIR
# The dependency on debootstrap's Makefile is to help make determine whether or
# not the debootstrap build directory needs to be updated.
${DEBOOTSTRAP_RULE}: ${DEBOOTSTRAP_SOURCE_DIR}/Makefile
	-rm -r ${DEBOOTSTRAP_BUILD_DIR} 2> /dev/null
	cp -a ${DEBOOTSTRAP_SOURCE_DIR} ${DEBOOTSTRAP_BUILD_DIR}
	${MAKE} -C ${DEBOOTSTRAP_BUILD_DIR}
	${MAKE} -C ${DEBOOTSTRAP_BUILD_DIR} DESTDIR=${DEBOOTSTRAP_INSTALL_DIR} install
	touch $@
endif

endif	# ifndef OPTIONS_FILE_SOURCED

###############################################################################
# Install build files (mainly for Debian packaging)

install-pgi:
	install -m 755 -d $(DESTDIR)$(PGI_DIR)
	if ! head -1 debian/changelog | cut -d\( -f2 | cut -d\) -f1 > \
	$(DESTDIR)$(PGI_DIR)/pgi_version; then \
		echo "ERROR: unable to determine PGI version from debian/changelog!"; \
		exit 1; \
	fi

	cd doc && ${MAKE}
	install -m 755 -d $(DESTDIR)$(datadir)/doc/pgi
	install -m 644 README $(DESTDIR)$(datadir)/doc/pgi
	install -m 644 doc/guide.html $(DESTDIR)$(datadir)/doc/pgi
	install -m 644 doc/guide.txt $(DESTDIR)$(datadir)/doc/pgi
	install -m 644 doc/usermanual.html $(DESTDIR)$(datadir)/doc/pgi
	install -m 644 doc/usermanual.txt $(DESTDIR)$(datadir)/doc/pgi
	install -m 755 -d $(DESTDIR)$(mandir)/man1
	install -m 644 doc/pgi-build.1 $(DESTDIR)$(mandir)/man1
	install -m 755 -d $(DESTDIR)$(ETC_DIR)
	install -m 755 -d $(DESTDIR)$(bindir)
	install -m 755 -d $(DESTDIR)$(PGI_DIR)
	install -m 644 Makefile $(DESTDIR)$(PGI_DIR)
	install -d $(DESTDIR)$(ETC_DIR)
	install -m 644 options $(DESTDIR)$(ETC_DIR)
	install -m 755 pgi-build $(DESTDIR)$(bindir)
	install -m 644 busybox.h $(DESTDIR)$(PGI_DIR)/busybox.h
	install -m 755 busybox.mkll $(DESTDIR)$(PGI_DIR)/busybox.mkll
	install -m 755 busybox.sh $(DESTDIR)$(PGI_DIR)/busybox.sh

#	archive dir
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato/alpha
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato/arm
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato/i386
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato/m68k
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato/powerpc
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/potato/sparc
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink/alpha
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink/arm
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink/i386
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink/m68k
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink/powerpc
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/slink/sparc
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/sparc-etc
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/slink
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/potato
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/slink
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/woody
	install -m 755 -d $(DESTDIR)$(PGI_DIR)/

	install -m 644 archive/Makefile $(DESTDIR)$(PGI_DIR)/archive/Makefile
	install -m 644 archive/debian-cd/Makefile $(DESTDIR)$(PGI_DIR)/archive/debian-cd/Makefile
	install -m 644 archive/debian-cd/README $(DESTDIR)$(PGI_DIR)/archive/debian-cd/README
	install -m 644 archive/debian-cd/README.devel $(DESTDIR)$(PGI_DIR)/archive/debian-cd/README.devel
	install -m 755 archive/debian-cd/build.sh $(DESTDIR)$(PGI_DIR)/archive/debian-cd/build.sh
	install -m 755 archive/debian-cd/build_all.sh $(DESTDIR)$(PGI_DIR)/archive/debian-cd/build_all.sh
	install -m 644 archive/debian-cd/changelog $(DESTDIR)$(PGI_DIR)/archive/debian-cd/changelog
	install -m 644 archive/debian-cd/copyright $(DESTDIR)$(PGI_DIR)/archive/debian-cd/copyright
	install -m 644 archive/debian-cd/tasks/Debian_potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/Debian_potato
	install -m 644 archive/debian-cd/tasks/Debian_sid $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/Debian_sid
	install -m 644 archive/debian-cd/tasks/Debian_woody $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/Debian_woody
	install -m 644 archive/debian-cd/tasks/README $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/README
	install -m 644 archive/debian-cd/tasks/base-woody $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/base-woody
	install -m 644 archive/debian-cd/tasks/empty $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/empty
	install -m 644 archive/debian-cd/tasks/exclude-potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/exclude-potato
	install -m 644 archive/debian-cd/tasks/exclude-src-potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/exclude-src-potato
	install -m 644 archive/debian-cd/tasks/forcd1 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/forcd1
	install -m 644 archive/debian-cd/tasks/interesting-fromcd23 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/interesting-fromcd23
	install -m 644 archive/debian-cd/tasks/interesting-redhat $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/interesting-redhat
	install -m 644 archive/debian-cd/tasks/interesting-tasks-potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/interesting-tasks-potato
	install -m 644 archive/debian-cd/tasks/kernel-related-potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/kernel-related-potato
	install -m 644 archive/debian-cd/tasks/linuxexpoamsterdam2001 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/linuxexpoamsterdam2001
	install -m 644 archive/debian-cd/tasks/linuxtag2000 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/linuxtag2000
	install -m 644 archive/debian-cd/tasks/popularity-contest $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/popularity-contest
	install -m 644 archive/debian-cd/tasks/popularity-contest-potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/popularity-contest-potato
	install -m 644 archive/debian-cd/tasks/popularity-contest-woody $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/popularity-contest-woody
	install -m 644 archive/debian-cd/tasks/task-woody $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/task-woody
	install -m 644 archive/debian-cd/tasks/unexclude-CD2-potato $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/unexclude-CD2-potato
	install -m 644 archive/debian-cd/tasks/xservers-XFree3 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tasks/xservers-XFree3
	install -m 755 archive/debian-cd/tools/add-bin-doc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/add-bin-doc
	install -m 755 archive/debian-cd/tools/add_dirs $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/add_dirs
	install -m 755 archive/debian-cd/tools/add_files $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/add_files
	install -m 755 archive/debian-cd/tools/add_packages $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/add_packages
	install -m 755 archive/debian-cd/tools/add_secured $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/add_secured
	install -m 755 archive/debian-cd/tools/apt-selection $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/apt-selection
	install -m 755 archive/debian-cd/tools/boot/potato/boot-alpha $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-alpha
	install -m 755 archive/debian-cd/tools/boot/potato/boot-arm $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-arm
	install -m 755 archive/debian-cd/tools/boot/potato/boot-i386 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-i386
	install -m 644 archive/debian-cd/tools/boot/potato/boot-i386.calc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-i386.calc
	install -m 755 archive/debian-cd/tools/boot/potato/boot-m68k $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-m68k
	install -m 644 archive/debian-cd/tools/boot/potato/boot-m68k.calc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-m68k.calc
	install -m 755 archive/debian-cd/tools/boot/potato/boot-powerpc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-powerpc
	install -m 644 archive/debian-cd/tools/boot/potato/boot-powerpc.calc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-powerpc.calc
	install -m 755 archive/debian-cd/tools/boot/potato/boot-sparc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-sparc
	install -m 644 archive/debian-cd/tools/boot/potato/boot-sparc.calc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/boot-sparc.calc
	install -m 755 archive/debian-cd/tools/boot/potato/post-boot-alpha $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/post-boot-alpha
	install -m 755 archive/debian-cd/tools/boot/potato/post-boot-powerpc $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/post-boot-powerpc
	install -m 644 archive/debian-cd/tools/boot/potato/sparc-etc/boot-msg.txt $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/sparc-etc/boot-msg.txt
	install -m 644 archive/debian-cd/tools/boot/potato/sparc-etc/debian.txt $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/sparc-etc/debian.txt
	install -m 644 archive/debian-cd/tools/boot/potato/sparc-etc/silo.conf $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/potato/sparc-etc/silo.conf
	install -m 755 archive/debian-cd/tools/boot/woody/boot-alpha $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody/boot-alpha
	install -m 755 archive/debian-cd/tools/boot/woody/boot-arm $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody/boot-arm
	install -m 755 archive/debian-cd/tools/boot/woody/boot-hppa $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody/boot-hppa
	install -m 755 archive/debian-cd/tools/boot/woody/boot-i386 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody/boot-i386
	install -m 755 archive/debian-cd/tools/boot/woody/boot-ia64 $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody/boot-ia64
	install -m 755 archive/debian-cd/tools/boot/woody/boot-m68k $(DESTDIR)$(PGI_DIR)/archive/debian-cd/tools/boot/woody/boot-m68k

=== archive/Makefile ===
# $Progeny: Makefile,v 1.27 2002/04/22 21:14:53 branden Exp $

SHELL=			/bin/sh -e

MKISOFS_OPTS=		-L -l -r

ifeq ($(ARCH),i386)
MKISOFS_BOOT_OPTS=	-b install-2.88
endif
ifeq ($(ARCH),ia64)
MKISOFS_BOOT_OPTS=	-no-emul-boot -b install
endif

all:
	$(MAKE) -C debian-cd distclean CODENAME=$(SUITE) MIRROR=$(PGI_BUILD_MIRROR)
	$(MAKE) -C debian-cd status CODENAME=$(SUITE) MIRROR=$(PGI_BUILD_MIRROR)
ifeq ($(INCLUDE_SOURCE_PACKAGES),1)
	$(MAKE) -C debian-cd list TASK=$(ETC_DIR)/package_list SIZELIMIT1=$(shell echo $$(( 650*1024*1024 - $$(cat $(TDIR)/installer-files.fs.size) )) ) CODENAME=$(SUITE) MIRROR=$(PGI_BUILD_MIRROR)
else
	$(MAKE) -C debian-cd bin-list TASK=$(ETC_DIR)/package_list SIZELIMIT1=$(shell echo $$(( 650*1024*1024 - $$(cat $(TDIR)/installer-files.fs.size) )) ) CODENAME=$(SUITE) MIRROR=$(PGI_BUILD_MIRROR)
endif
	$(MAKE) -C debian-cd bin-images CODENAME=$(SUITE) MIRROR=$(PGI_BUILD_MIRROR) MKISOFS_OPTS="$(MKISOFS_OPTS)" MKISOFS_BOOT_OPTS="$(MKISOFS_BOOT_OPTS)"
ifeq ($(INCLUDE_SOURCE_PACKAGES),1)
	$(MAKE) -C debian-cd src-images CODENAME=$(SUITE) MIRROR=$(PGI_BUILD_MIRROR) MKISOFS_OPTS="$(MKISOFS_OPTS)"
endif

# nothing to do
clean:

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== debootstrap/Makefile ===
# $Progeny: Makefile,v 1.3 2002/04/22 21:15:17 branden Exp $

CC=gcc
CFLAGS=-Wall -W -O2

ARCH := $(shell dpkg --print-architecture)
setarchdevs = $(if $(findstring $(ARCH),$(1)),$(2))

DEVS := generic hde hdf hdg hdh sde sdf sdg sdh scd-all initrd input usb md lp rtc \
        $(call setarchdevs,i386,isdn-io eda edb sonycd mcd mcdx cdu535 \
                                optcd sjcd cm206cd gscd lmscd sbpcd \
                                aztcd bpcd dac960 ida fd0 fd1 ataraid cciss) \
        $(call setarchdevs,sparc,hdc hdd busmice) \
        $(call setarchdevs,m68k,fd0 fd1 adc add ade adf hdc hdd) \
        $(call setarchdevs,powerpc,hdc hdd fd0 fd1 isdn-io m68k-mice)

all: pkgdetails devices.tar.gz debootstrap-arch
clean:
	rm -f pkgdetails pkgdetails.o devices.tar.gz debootstrap-arch
	rm -rf dev

DSDIR=$(DESTDIR)/usr/lib/debootstrap
install:
	mkdir -p $(DSDIR)/scripts
	mkdir -p $(DESTDIR)/usr/sbin
	mkdir -p $(DESTDIR)/usr/share/man/man8
	install -o root -g root -m 0644 slink $(DSDIR)/scripts/
	install -o root -g root -m 0644 potato $(DSDIR)/scripts/
	install -o root -g root -m 0644 woody $(DSDIR)/scripts/
	ln -sf woody $(DSDIR)/scripts/sid
	install -o root -g root -m 0644 functions $(DSDIR)/
	install -o root -g root -m 0755 pkgdetails $(DSDIR)/
	install -o root -g root -m 0644 devices.tar.gz $(DSDIR)/
	install -o root -g root -m 0644 debootstrap-arch $(DSDIR)/arch
	install -o root -g root -m 0755 debootstrap.8 $(DESTDIR)/usr/share/man/man8/
	install -o root -g root -m 0755 debootstrap $(DESTDIR)/usr/sbin/

pkgdetails: pkgdetails.o
	$(CC) -o $@ $^

debootstrap-arch:
	echo $(ARCH) >debootstrap-arch

devices.tar.gz:
	rm -rf dev

	mkdir -p dev
	chown 0.0 dev
	chmod 755 dev

	(cd dev && /sbin/MAKEDEV $(DEVS))

ifeq ($(ARCH),powerpc)
#	Maybe remove amiga/atari mice also? What about usbmouse?
	rm -f dev/adbmouse
	ln -sf input/mice dev/mouse
	ln -sf input/js0 dev/js0
	ln -sf input/js1 dev/js1
endif

	@if ! find dev -maxdepth 0 -perm 755 -uid 0 -gid 0 | \
	        grep -q "^dev$$"; \
	then \
	   echo "======================================================="; \
	   echo "ERROR"; echo; \
	   echo "./dev has bad permissions! should be 755 root.root. Was:"; \
	   ls -ld ./dev; \
	   echo "======================================================="; \
	   false; \
	fi

	tar cf - dev | gzip -9 >devices.tar.gz
	rm -rf dev

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== doc/Makefile ===
# $Progeny: Makefile,v 1.10 2002/04/22 21:15:18 branden Exp $

doctools=../doctools

GUIDE_FILES=	\
		guide.xml \
		pgi-build.refentry
USERMANUAL_FILES= \
		usermanual.xml

IGNOREFILES=	pgi-build.1 guide.html guide.ps guide.pdf guide.txt \
		usermanual.txt usermanual.html usermanual.ps usermanual.pdf

all: .cvsignore pgi-build.1 guide.html guide.txt usermanual.html usermanual.txt

guide.html: ${GUIDE_FILES}
usermanual.html: ${USERMANUAL_FILES}

validate: validate-guide validate-usermanual

validate-guide:
	$(call validate,guide.xml)

validate-usermanual:
	$(call validate,usermanual.xml)

clean:

maintainer-clean:
	rm -f *.1

.PHONY: all validate validate-guide validate-manual clean maintainer-clean

include ${doctools}/docbook.mk

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== stage0/Makefile ===
# $Progeny: Makefile,v 1.59 2002/04/22 21:29:14 branden Exp $

SHELL=		/bin/sh -e
TOOLS=		$(RELEASE_tools)

all: $(TDIR)/initrd-reboot $(TDIR)/initrd.installer.gz $(TDIR)/initrd.system.gz

# Generate a modules.dep file for the kernel to be used by the initrds.
$(TDIR)/modules.dep:
	-rm -r $(TDIR)/depmod_kludge
	mkdir -p $(TDIR)/depmod_kludge/lib/modules
	# this really sucks; I wish you could tell depmod to write to standard output
	cp --dereference --recursive /lib/modules/$(KERNEL_VERSION) $(TDIR)/depmod_kludge/lib/modules
	$(SU_CMD) depmod -b $(TDIR)/depmod_kludge -F /boot/System.map-$(KERNEL_VERSION) -a $(KERNEL_VERSION)
	cp $(TDIR)/depmod_kludge/lib/modules/$(KERNEL_VERSION)/modules.dep $@.tmp
	rm -r $(TDIR)/depmod_kludge
	mv $@.tmp $@

# Compile the quick-and-easy non-init-based reboot utility.
$(TDIR)/initrd-reboot: initrd-reboot.c
	$(CC) -o $@.tmp initrd-reboot.c
	strip --strip-unneeded --remove-section=.note \
	 --remove-section=.comment $@.tmp
	mv $@.tmp $@

# Create a busybox source tree for use by the installer initrd.
$(TDIR)/$(BUSYBOX)-initrd: /usr/src/$(BUSYBOX).tar.gz
	gzip -dc /usr/src/$(BUSYBOX).tar.gz | \
		(cd $(TDIR) && tar -xf -)
	mv $(TDIR)/$(BUSYBOX) $(TDIR)/$(BUSYBOX)-initrd

# Compile the installer initrd's version of the busybox binary.
$(TDIR)/busybox.initrd: $(TDIR)/$(BUSYBOX)-initrd
	cp $(PGI_DIR)/busybox.h $(TDIR)/$(BUSYBOX)-initrd/Config.h
	cd $(TDIR)/$(BUSYBOX)-initrd && $(MAKE)
	cp $(TDIR)/$(BUSYBOX)-initrd/busybox $@

# Generate the installer initrd's symlinks to the busybox binary.
$(TDIR)/busybox.initrd.links: $(TDIR)/busybox.initrd
	cd $(TDIR)/$(BUSYBOX)-initrd && \
		sh $(PGI_DIR)/busybox.mkll Config.h applets.h > $@

# Create the installer initrd's filesystem.
$(TDIR)/initrd.installer: $(TDIR)/busybox.initrd $(TDIR)/busybox.initrd.links $(TDIR)/modules.dep
	@(dpkg -s libc6-pic || dpkg -s libc6.1-pic ) 2> /dev/null | egrep -q "Status: install ok installed" \
	 || (echo "ERROR: You must install libc6-pic or libc6.1-pic to build a small initrd" >&2;\
	     exit 1)
	-$(SU_CMD) rm -rf $@.fs $@.mnt
	mkdir $@.mnt $@.fs
	TOOLS=$(TOOLS) $(SU_CMD) ./mkinitrd --installer $(KERNEL_VERSION) $@.fs \
	  $$(sh $(TOOLS)/detectmodules.sh $(KERNEL_VERSION))
	dd if=/dev/zero of=$@.tmp bs=1k count=$(INITRD_FS_SIZE)
	mke2fs -Fq $@.tmp
	$(SU_CMD) mount -oloop -text2 $@.tmp $@.mnt
	-$(SU_CMD) rmdir $@.mnt/lost+found
	$(SU_CMD) bash -c "(cd $@.fs ; tar -c .) | (cd $@.mnt ; tar -x)"
	$(SU_CMD) chown -R root.root $@.mnt
	$(SU_CMD) umount $@.mnt
	mv $@.tmp $@

# Compress the installer initrd.
$(TDIR)/initrd.installer.gz: $(TDIR)/initrd.installer
	gzip -9 < $(TDIR)/initrd.installer > $@

# Create the system initrd's filesystem.
$(TDIR)/initrd.system: $(TDIR)/busybox.initrd $(TDIR)/busybox.initrd.links $(TDIR)/modules.dep
	# ensure that we have a "reduceable" C library
	@(dpkg -s libc6-pic || dpkg -s libc6.1-pic ) | egrep -q "Status: install ok installed" \
	 || (echo "ERROR: You must install libc6-pic or libc6.1-pic to build a small initrd" >&2;\
	     exit 1)
	-$(SU_CMD) rm -rf $@.fs $@.mnt
	mkdir $@.mnt $@.fs
	TOOLS=$(TOOLS) $(SU_CMD) ./mkinitrd --system $(KERNEL_VERSION) $@.fs \
	  $$(sh $(TOOLS)/detectmodules.sh $(KERNEL_VERSION))
	dd if=/dev/zero of=$@.tmp bs=1k count=$(INITRD_FS_SIZE)
	mke2fs -Fq $@.tmp
	$(SU_CMD) mount -oloop -text2 $@.tmp $@.mnt
	-$(SU_CMD) rmdir $@.mnt/lost+found
	$(SU_CMD) bash -c "(cd $@.fs ; tar -c .) | (cd $@.mnt ; tar -x)"
	$(SU_CMD) chown -R root.root $@.mnt
	$(SU_CMD) umount $@.mnt
	mv $@.tmp $@

# Compress the system initrd.
$(TDIR)/initrd.system.gz: $(TDIR)/initrd.system
	gzip -9 < $(TDIR)/initrd.system > $@

clean:
	rm -f \
		$(TDIR)/modules.dep \
		$(TDIR)/initrd-reboot \
		$(TDIR)/busybox.initrd \
		$(TDIR)/busybox.initrd.links \
		$(TDIR)/initrd.installer \
		$(TDIR)/initrd.installer.gz \
		$(TDIR)/initrd.system \
		$(TDIR)/initrd.system.gz \
	rm -rf \
		$(TDIR)/$(BUSYBOX)-initrd \
		$(TDIR)/initrd.installer.fs \
		$(TDIR)/initrd.installer.mnt \
		$(TDIR)/initrd.system.fs \
		$(TDIR)/initrd.system.mnt

distclean: clean

.PHONY: all clean distclean

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== stage1/Makefile ===
# $Progeny: Makefile,v 1.53 2002/04/23 20:38:28 branden Exp $

SHELL=		/bin/sh -e
TOOLS=		$(RELEASE_tools)

# Makefile quoting is nasty... double $ and \# lie within
# This gets rid of comment lines, empty lines, and lines
# containing nothing but white space.
COMMENTFILTER=	(sed -e 's/\#.*$$//' | egrep -v '^[[:space:]]*$$')

all: $(TDIR)/live

# Create a busybox source tree for use by the live filesystem.
$(TDIR)/$(BUSYBOX)-live: /usr/src/$(BUSYBOX).tar.gz
	gzip -dc /usr/src/$(BUSYBOX).tar.gz | \
		(cd $(TDIR) && tar -xf -)
	mv $(TDIR)/$(BUSYBOX) $@

# Compile the live filesystem's version of the busybox binary.
$(TDIR)/busybox.live: $(TDIR)/$(BUSYBOX)-live
	cp $(PGI_DIR)/busybox.h $(TDIR)/$(BUSYBOX)-live/Config.h
	cd $(TDIR)/$(BUSYBOX)-live && (echo -n "APPLET_SOURCES := "; BB_SRC_DIR= sh $(PGI_DIR)/busybox.sh Config.h -DPGI_LIVE_FS) > applet_source_list
	cd $(TDIR)/$(BUSYBOX)-live && $(MAKE) CFLAGS_EXTRA=-DPGI_LIVE_FS
	cp $(TDIR)/$(BUSYBOX)-live/busybox $@

# Generate the live filesystem's symlinks to the busybox binary.
$(TDIR)/busybox.live.links: $(TDIR)/busybox.live
	cd $(TDIR)/$(BUSYBOX)-live && \
		sh $(PGI_DIR)/busybox.mkll Config.h applets.h -DPGI_LIVE_FS > $@

# Generate the list of "extra packages" we will be passing to
# debootstrap for installation.
$(TDIR)/extra_packages:
	-cat internal.extra_packages $(ARCH)/extra_packages $(ETC_DIR)/extra_packages \
	  | $(COMMENTFILTER) > $@.in
	python $(TOOLS)/pgi-calc-deps.py < $@.in > $@.tmp
	rm $@.in
	mv $@.tmp $@

# Generate a Glade interface file for the graphical installer.
$(TDIR)/installer.glade:
	sed -e "s/@VERSION@/$(VERSION)/" < installer.glade.in > $@

# Generate the list of devices that we will place on the live
# filesystem.
$(TDIR)/live.devices.list:
	-cat internal.devices.list $(ARCH)/devices.list $(ETC_DIR)/live.devices.list > $@

# Generate the list of directories to be created on the live
# filesystem.
$(TDIR)/live.dirs.list:
	-cat internal.dirs.list $(ARCH)/dirs.list $(ETC_DIR)/live.dirs.list > $@

# Generate the list of files to be copied to the live filesystem
# (not including shared libraries needed by anything in this
# list).  Also, check to make sure that everything we need is
# actually present.
$(TDIR)/live.files.list:
	-cat internal.files.list $(ARCH)/files.list $(ETC_DIR)/live.files.list > $@.tmp
	cat $@.tmp | $(COMMENTFILTER) | awk '{ print $$1 }' \
		| (while read file; do if [ ! -e $$file ]; then echo $$file; \
			fi; done) \
		> $(TDIR)/missing-files
	if [ $$(cat $(TDIR)/missing-files | wc -l) -gt 0 ]; then \
		echo "Files missing; look in $(TDIR)/missing-files for a list"; \
		exit 1; \
	fi
	rm $(TDIR)/missing-files
	mv $@.tmp $@

# Generate the messages file to be used by the "welcome" and
# "finished" screens of the text-mode and graphical installers.
$(TDIR)/messages:
	-cat $(ETC_DIR)/messages > $@

# Compile a simple init replacement that launches shells on
# virtual consoles 2 through 6.
$(TDIR)/shellspawn: shellspawn.c
	cc -o $@ shellspawn.c

# Produce the live filesystem.
$(TDIR)/live: $(TDIR)/busybox.live \
              $(TDIR)/busybox.live.links \
              $(TDIR)/extra_packages \
              $(TDIR)/installer.glade \
              $(TDIR)/live.devices.list  \
              $(TDIR)/live.dirs.list \
              $(TDIR)/live.files.list \
              $(TDIR)/messages \
              $(TDIR)/shellspawn
	-$(SU_CMD) rm -r $@.tmp $@
	mkdir $@.tmp
	@echo Creating live filesystem...
	@printf "\tcreating required directories...\n"
	cat $(TDIR)/live.dirs.list | $(COMMENTFILTER) | \
		while read mode dir; do \
			echo mkdir -p -m $$mode $@.tmp/$$dir; \
			mkdir -p -m $$mode $@.tmp/$$dir || exit 1; \
		done
	ln -s . $@.tmp/usr
	ln -s bin $@.tmp/sbin
	ln -s . $@.tmp/usr/X11R6
	ln -s bash $@.tmp/bin/sh
	@printf "\tcopying the discover databases...\n"
	# Copy in discover databases.  Use kernel 2.4 databases
	# preferentially, if they exist.
	for discoverdb in pci pcmcia usb; do \
		basekern=$$(echo $$KERNEL_VERSION | cut -d. -f1-2); \
		if [ -f /usr/share/discover/$${discoverdb}-$$basekern.list ]; then \
			discoverfn=$$discoverdb-$$basekern.lst; else \
			discoverfn=$$discoverdb.lst; \
		fi; \
		install -m 644 /usr/share/discover/$$discoverfn \
			$@.tmp/share/discover/$$discoverfn; \
	done
	@printf "\tcopying the PGI Python modules...\n"
	install -m 755 -d $@.tmp/lib/python2.1/site-packages/pgi
	install -m 644 $(PGI_DIR)/python/pgi/__init__.py $@.tmp/lib/python2.1/site-packages/pgi
	install -m 644 $(PGI_DIR)/python/pgi/auto_partition_base.py $@.tmp/lib/python2.1/site-packages/pgi
	install -m 644 $(PGI_DIR)/python/pgi/auto_partition-$(ARCH).py $@.tmp/lib/python2.1/site-packages/pgi/auto_partition.py
	install -m 644 $(PGI_DIR)/python/pgi/base.py $@.tmp/lib/python2.1/site-packages/pgi
	install -m 644 $(PGI_DIR)/python/pgi/bootloader-$(ARCH).py $@.tmp/lib/python2.1/site-packages/pgi/bootloader.py
	install -m 644 $(PGI_DIR)/python/pgi/common.py $@.tmp/lib/python2.1/site-packages/pgi
	@printf "\tcopying the PGI installer...\n"
	install -m 755 $(PGI_DIR)/stage1/stage1.sh $@.tmp/share/installer
	install -m 755 $(PGI_DIR)/stage1/installer-druid $@.tmp/share/installer
	install -m 755 $(PGI_DIR)/stage1/xinitrc $@.tmp/bin
	install -m 755 $(PGI_DIR)/stage1/list-devices.py $@.tmp/bin/list-devices
	install -m 644 $(ETC_DIR)/sources.list.dist $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/syslog-install.conf $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/theme.jl $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/arrow.xpm $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/check.xpm $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/installer-text.sh $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/installer-x.sh $@.tmp/share/installer
	install -m 755 $(PGI_DIR)/stage1/pgilogs2disk $@.tmp/bin
	install -m 644 $(TDIR)/messages $@.tmp/share/installer
	cat $(TDIR)/extra_packages | $(COMMENTFILTER) \
		> $@.tmp/share/installer/extra_packages
	if [ -e $(ETC_DIR)/preinst.sh ]; then \
		install -m 644 $(ETC_DIR)/preinst.sh $@.tmp/share/installer; \
	fi
	if [ -e $(ETC_DIR)/postinst.sh ]; then \
		install -m 644 $(ETC_DIR)/postinst.sh $@.tmp/share/installer; \
	fi
	if [ -e $(ETC_DIR)/logoicon.xpm ]; then \
		install -m 644 $(ETC_DIR)/logoicon.xpm $@.tmp/share/installer; \
	fi
	if [ "$$(echo $(ETC_DIR)/root_window.*)" != "$(ETC_DIR)/root_window.*" ]; then \
		install -m 644 $(ETC_DIR)/root_window.* $@.tmp/share/installer; \
	fi
	install -m 644 $(PGI_DIR)/stage1/setup-base-text.py $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/setup-bootloader-text.py $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/setup-finalize-text.py $@.tmp/share/installer
	install -m 644 $(PGI_DIR)/stage1/get-message.py $@.tmp/share/installer
	@printf "\tcopying $(KERNEL_VERSION) kernel and modules...\n"
	install -m 755 -d $@.tmp/kernel/boot
	install -m 755 -d $@.tmp/kernel/lib/modules/$(KERNEL_VERSION)
	install -m 644 /boot/System.map-$(KERNEL_VERSION) $@.tmp/kernel/boot
	install -m 644 /boot/config-$(KERNEL_VERSION) $@.tmp/kernel/boot
# XXX: might want to define a KERNEL_PATH variable in the options file
ifeq ($(ARCH),powerpc)
	install -m 644 /boot/vmlinux-$(KERNEL_VERSION) $@.tmp/kernel/boot
else
	install -m 644 /boot/vmlinuz-$(KERNEL_VERSION) $@.tmp/kernel/boot
endif
#	-install -m 644 /boot/initrd.img-$(KERNEL_VERSION) $@.tmp/kernel/boot
	install -m 644 $(TDIR)/initrd.system.gz \
	  $@.tmp/kernel/boot/initrd.img-$(KERNEL_VERSION)
	cp -a /lib/modules/$(KERNEL_VERSION) $@.tmp/kernel/lib/modules
	@printf "\tcopying generated installer files...\n"
	install -m 644 $(TDIR)/installer.glade $@.tmp/share/installer
	@printf "\tcopying shellspawn binary...\n"
	install -m 755 $(TDIR)/shellspawn $@.tmp/sbin
	@printf "\tcopying required files...\n"
	cat $(TDIR)/live.files.list | $(COMMENTFILTER) | \
		while read file name; do \
			[ -n "$$name" ] || name=$$file; \
			echo install -m 755 -d $$(dirname $$name); \
			install -m 755 -d $@.tmp/$$(dirname $$name); \
			echo cp --preserve --dereference $$file $@.tmp/$$name; \
			cp --preserve --dereference $$file $@.tmp/$$name || exit 1; \
		done
	@printf "\tbusybox...\n"
	install -m 755 $(TDIR)/busybox.live $@.tmp/bin/busybox
	@(cd $@.tmp/bin; \
		while read bin; do \
			echo ln -sf busybox $$(basename $$bin); \
			ln -sf busybox $$(basename $$bin) || exit 1; \
		done ) < $(TDIR)/busybox.live.links
	@printf "\tdebootstrap (from ${DEBOOTSTRAP_INSTALL_DIR}/)...\n"
	cp -a ${DEBOOTSTRAP_INSTALL_DIR}/usr/lib/debootstrap $@.tmp/usr/lib
	cp ${DEBOOTSTRAP_INSTALL_DIR}/usr/sbin/debootstrap $@.tmp/usr/sbin
	@printf "\tcopying XF86Config.template...\n"
	install -m 644 XF86Config.template $@.tmp
	@printf "\tmtools symlink hack...\n"
	ln -sf mtools $@.tmp/bin/mformat
	@printf "\txkb dir copy hack...\n"
	cp --dereference -r /etc/X11/xkb $@.tmp/lib/X11/xkb
	rm -rf $@.tmp/lib/X11/xkb/compiled
	ln -sf /var/lib/xkb $@.tmp/lib/X11/xkb/compiled
	@printf "\tX server modules directory hack...\n"
	cp --dereference -r /usr/X11R6/lib/modules $@.tmp/lib
	@printf "\tX fonts copy hack...\n"
	mkdir -p $@.tmp/lib/X11/fonts
	cp --dereference -r /usr/X11R6/lib/X11/fonts/100dpi $@.tmp/lib/X11/fonts
	cp --dereference -r /usr/X11R6/lib/X11/fonts/misc $@.tmp/lib/X11/fonts
	@printf "\tX locale support copy hack...\n"
	mkdir -p $@.tmp/lib/X11/locale
	cp --dereference -r /usr/X11R6/lib/X11/locale/C $@.tmp/lib/X11/locale
	cp --dereference -r /usr/X11R6/lib/X11/locale/iso8859-1 $@.tmp/lib/X11/locale
	cp /usr/X11R6/lib/X11/locale/locale.alias \
		/usr/X11R6/lib/X11/locale/locale.dir \
		$@.tmp/lib/X11/locale
	@printf "\txkbcomp symlink hack...\n"
	ln -sf /live/bin/xkbcomp $@.tmp/lib/X11/xkb/xkbcomp
	@printf "\tcopying libraries required by commands...\n"
	for i in $$(sh $(PGI_DIR)/tools/so-deps.sh \
			$@.tmp/bin/* \
			$@.tmp/usr/bin/* \
			$@.tmp/sbin/* \
			$@.tmp/usr/sbin/*); do \
		cp -f $$i $@.tmp/lib; \
	done
	@printf "\tcopying libraries required by Python...\n"
	find $@.tmp/lib/python2.1 -name "*.so" | \
		xargs sh $(PGI_DIR)/tools/so-deps.sh | \
		while read lib; do \
			cp -f $$lib $@.tmp/lib; \
		done
	$(SU_CMD) chown root.root -R $@.tmp
	@printf "\tcreating device files...\n"
	cat $(TDIR)/live.devices.list | $(COMMENTFILTER) | \
		( cd $@.tmp/dev; \
			while read dev; do \
				echo $(SU_CMD) /sbin/MAKEDEV $$dev; \
				$(SU_CMD) /sbin/MAKEDEV $$dev || exit 1; \
			done )
	mv $@.tmp $@

clean:
	rm -f \
		$(TDIR)/busybox.live \
		$(TDIR)/busybox.live.links \
		$(TDIR)/extra_packages \
		$(TDIR)/installer.glade \
		$(TDIR)/messages \
		$(TDIR)/missing-files \
		$(TDIR)/live.devices.list \
		$(TDIR)/live.dirs.list \
		$(TDIR)/live.files.list \
		$(TDIR)/shellspawn
	rm -rf \
		$(TDIR)/$(BUSYBOX)-live \
		$(TDIR)/live

distclean: clean

.PHONY: all clean distclean

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== user-configlet/Makefile ===
.POSIX:

# $Progeny: Makefile,v 1.3 2002/04/22 21:29:14 branden Exp $

# XXX: This is only temporary; autoconfiscation is needed for i18n anyway.

prefix=		/usr
datadir=	${prefix}/share
cfgletsdir=	${datadir}/configlets
pkgcfgletsdir=	${cfgletsdir}/user

INSTALL=	/usr/bin/install
INSTALL_DATA=	${INSTALL} -c -m 444 -o root -g root
INSTALL_DIR=	${INSTALL} -d -m 755 -o root -g root
INSTALL_MODULE=	${INSTALL_DATA}

DATA_FILES=	\
		main.glade \
		user.xpm
PYTHON_FILES=	main.py

all: ${DATA_FILES} ${PYTHON_FILES}

install: ${DATA_FILES} ${PYTHON_FILES}
	${INSTALL_DIR} ${DESTDIR}${pkgcfgletsdir}
	for i in ${DATA_FILES}; do\
		${INSTALL_DATA} $${i} ${DESTDIR}${pkgcfgletsdir}/$${i};\
	done
	for i in ${PYTHON_FILES}; do\
		${INSTALL_MODULE} $${i} ${DESTDIR}${pkgcfgletsdir}/$${i};\
	done

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== archive/debian-cd/Makefile ===
#!/usr/bin/make -f

# Main Makefile for YACS
#
# Copyright 1999 Raphal Hertzog <hertzog@debian.org>
# See the README file for the license

# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell

# $Progeny: Makefile,v 1.22 2002/04/22 21:14:53 branden Exp $
#
# 2002-02-11 Branden Robinson
#    Debian -> $(VENDOR) in *INFO* variables
#    GNU/Linux -> $(PRODUCT) in *INFO* variables
#    add pgi-image and live stuff to bin-images rule
#
# 2002-02-16 Branden Robinson
#    Update rawlist rule to always include packages needed by debootstrap,
#        and packages needed by PGI.
#
# 2002-03-28 Branden Robinson
#    Update rawlist rule again; never use $(TASK) file, add
#    comments, and use local, forked version of debootstrap when
#    necessary.
#
# 2002-04-12 Branden Robinson
#    Update bin-images rule to use $(TDIR)/installer-files.fs
#    instead of pgi-image and live separately.

## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef SIZELIMIT
SIZELIMIT=$(shell echo -n $$[ 610 * 1024 * 1024 ])
endif
ifndef TASK
TASK=$(BASEDIR)/tasks/Debian_$(CODENAME)
endif
ifndef CAPCODENAME
CAPCODENAME:=$(shell perl -e "print ucfirst("$(CODENAME)")") # "
endif
ifndef BINDISKINFO
BINDISKINFO="$(VENDOR) $(PRODUCT) $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num ($$DATE)"
endif
ifndef SRCDISKINFO
SRCDISKINFO="$(VENDOR) $(PRODUCT) $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num ($$DATE)"
endif
# ND=No-Date versions for README
ifndef BINDISKINFOND
BINDISKINFOND="$(VENDOR) $(PRODUCT) $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num"
endif
ifndef SRCDISKINFOND
SRCDISKINFOND="$(VENDOR) $(PRODUCT) $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num"
endif
ifndef BINVOLID
ifeq ($(ARCH),powerpc)
BINVOLID="$(VENDOR) $(DEBVERSION) ppc Bin-$$num"
else
BINVOLID="$(VENDOR) $(DEBVERSION) $(ARCH) Bin-$$num"
endif
endif
ifndef SRCVOLID
SRCVOLID="$(VENDOR) $(DEBVERSION) Src-$$num"
endif
ifndef MKISOFS
export MKISOFS=/usr/bin/mkisofs
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r -T
#For symlink farmers
#MKISOFS_OPTS=-r -F . -T
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif
ifndef BOOTDISKS
export BOOTDISKS=$(MIRROR)/dists/$(CODENAME)/main/disks-$(ARCH)
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
list2cds=$(BASEDIR)/tools/list2cds
cds2src=$(BASEDIR)/tools/cds2src
master2tasks=$(BASEDIR)/tools/master2tasks
mirrorcheck=$(BASEDIR)/tools/mirror_check
add_packages=$(BASEDIR)/tools/add_packages
add_dirs=$(BASEDIR)/tools/add_dirs
add_bin_doc=$(BASEDIR)/tools/add-bin-doc
scanpackages=$(BASEDIR)/tools/scanpackages
scansources=$(BASEDIR)/tools/scansources
add_files=$(BASEDIR)/tools/add_files
set_mkisofs_opts=$(BASEDIR)/tools/set_mkisofs_opts
strip_nonus_bin=$(BASEDIR)/tools/strip-nonUS-bin
add_secured=$(BASEDIR)/tools/add_secured

BDIR=$(TDIR)/$(CODENAME)-$(ARCH)
ADIR=$(APTTMP)/$(CODENAME)-$(ARCH)
SDIR=$(TDIR)/$(CODENAME)-src

FIRSTDISKS=CD1 
ifdef FORCENONUSONCD1
FIRSTDISKS=CD1 CD1_NONUS
forcenonusoncd1=1
else
forcenonusoncd1=0
endif

## DEBUG STUFF ##

PrintVars:
	@num=1; \
	DATE=`date +%Y%m%d` ; \
	echo BINDISKINFO: ; \
        echo $(BINDISKINFO) ; \
	echo SRCDISKINFO: ; \
        echo $(SRCDISKINFO) ; \
	echo BINDISKINFOND: ; \
        echo $(BINDISKINFOND) ; \
	echo SRCDISKINFOND: ; \
        echo $(SRCDISKINFOND) ; \
	echo BINVOLID: ; \
        echo $(BINVOLID) ; \
	echo SRCVOLID: ; \
        echo $(SRCVOLID) ; \

## CHECKS ##

# Basic checks in order to avoid problems
ok=true
ifndef TDIR
ok=false
endif
ifndef BASEDIR
ok=false
endif
ifndef MIRROR
ok=false
endif
ifndef ARCH
ok=false
endif
ifndef CODENAME
ok=false
endif
ifndef OUT
ok=false
endif
# Never use NONFREE and EXTRANONFREE at the same time
ifdef NONFREE
ifdef EXTRANONFREE
ok=false
endif
endif
# If we have FORCENONUSONCD1 set, we must also have NONUS set
ifdef FORCENONUSONCD1
ifndef NONUS
ok=false
endif
endif

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

ok:
	@$(ok) || (echo \
	 "ERROR: Bad configuration. Please edit CONF.sh and source it ..." \
	 && false)

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(TDIR) $(BDIR) $(SDIR) $(ADIR)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(SDIR):
	$(Q)mkdir -p $(SDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
	$(Q)mkdir -p $(ADIR)/apt-ftparchive-db

## CLEANINGS ##

# CLeans the current arch tree (but not packages selection info)
clean: ok bin-clean src-clean
bin-clean:
	$(Q)-rm -rf $(BDIR)/CD[1234567890]
	$(Q)-rm -rf $(BDIR)/*_NONUS
	$(Q)-rm -f $(BDIR)/*.filelist*
	$(Q)-rm -f  $(BDIR)/packages-stamp $(BDIR)/bootable-stamp \
	         $(BDIR)/upgrade-stamp
src-clean:
	$(Q)-rm -rf $(SDIR)/CD[1234567890]
	$(Q)-rm -rf $(SDIR)/*_NONUS
	$(Q)-rm -rf $(SDIR)/sources-stamp

# Completely cleans the current arch tree
realclean: distclean
distclean: ok bin-distclean src-distclean
bin-distclean:
	$(Q)-rm -rf $(BDIR)
	$(Q)-rm -rf $(ADIR)
src-distclean:
	$(Q)-rm -rf $(SDIR)


## STATUS and APT ##

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$(ARCH)/Packages.gz | \
	perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; \
	               print if (/^Priority: (required|important|standard)/m or \
		       /^Section: base/m);' \
	> $(ADIR)/status
	# Updating the apt database
	$(Q)$(apt) update
	#
	# Checking the consistence of the standard system
	# If this does fail, then launch make correctstatus
	#
	$(Q)$(apt) check || $(MAKE) correctstatus

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
	# You may need to launch correctstatus more than one time
	# in order to correct all dependencies
	#
	# Removing packages from the system :
	$(Q)set -e; \
	for i in `$(apt) deselected -f install`; do \
		echo $$i; \
		perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
		$(ADIR)/status; \
	done
	#
	# Adding packages to the system :
	$(Q)set -e; \
	for i in `$(apt) selected -f install`; do \
	  echo $$i; \
	  $(apt) cache dumpavail | perl -000 -ne \
	      "s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m; \
	       print if /^Package: \Q$$i\E\s*\$$/m;" \
	       >> $(ADIR)/status; \
	done
	#
	# Showing the output of apt-get check :
	$(Q)$(apt) check

apt-update: status
	@echo "Apt-get is updating his files ..."
	$(Q)$(apt) update


## GENERATING LISTS ##

# Deleting the list only
deletelist: ok
	$(Q)-rm $(BDIR)/rawlist
	$(Q)-rm $(BDIR)/list

# Generates the list of packages/files to put on each CD
list: bin-list src-list

# Generate the listing of binary packages
bin-list: ok apt-update genlist $(BDIR)/1.packages
$(BDIR)/1.packages:
	@echo "Dispatching the packages on all the CDs ..."
	$(Q)$(list2cds) $(BDIR)/list $(SIZELIMIT)
ifdef FORCENONUSONCD1
	$(Q)set -e; \
	 for file in $(BDIR)/*.packages; do \
	    newfile=$${file%%.packages}_NONUS.packages; \
	    cp $$file $$newfile; \
	    $(strip_nonus_bin) $$file $$file.tmp; \
	    if (cmp -s $$file $$file.tmp) ; then \
	        rm -f $$file.tmp $$newfile ; \
	    else \
	        echo Splitting non-US packages: $$file and $$newfile ; \
	        mv -f $$file.tmp $$file; \
	    fi ;\
	done
endif

# Generate the listing for sources CDs corresponding to the packages included
# in the binary set
src-list: bin-list $(SDIR)/1.sources
$(SDIR)/1.sources:
	@echo "Dispatching the sources on all the CDs ..."
	$(Q)$(cds2src) $(SIZELIMIT)
ifdef FORCENONUSONCD1
	$(Q)set -e; \
	 for file in $(SDIR)/*.sources; do \
	    newfile=$${file%%.sources}_NONUS.sources; \
	    cp $$file $$newfile; \
	    grep -v non-US $$file >$$file.tmp; \
	    if (cmp -s $$file $$file.tmp) ; then \
	        rm -f $$file.tmp $$newfile ; \
	    else \
	        echo Splitting non-US sources: $$file and $$newfile ; \
	        mv -f $$file.tmp $$file; \
	    fi ;\
	done
endif

# Generate the complete listing of packages from the task
# Build a nice list without doubles and without spaces
genlist: ok $(BDIR)/list
$(BDIR)/list: $(BDIR)/rawlist
	@echo "Generating the complete list of packages to be included ..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist \
		  > $(BDIR)/list

# Build the raw list (cpp output) with doubles and spaces
$(BDIR)/rawlist:
ifdef FORCENONUSONCD1
	$(Q)$(apt) cache dumpavail | \
		grep-dctrl -FSection -n -sPackage -e '^(non-US|non-us/main)' - | \
		sort | uniq > $(BDIR)/Debian_$(CODENAME)_nonUS
endif
	touch $@.in
	# Add PGI-specific stuff.
	# append debootstrap dependencies
ifdef DEBOOTSTRAP_INSTALL_DIR
	env DEBOOTSTRAP_DIR=$(DEBOOTSTRAP_INSTALL_DIR)/usr/lib/debootstrap $(DEBOOTSTRAP_INSTALL_DIR)/usr/sbin/debootstrap --arch $(ARCH) --print-debs $(CODENAME) | tr ' ' '\n' >> $@.in
else
	debootstrap --arch $(ARCH) --print-debs $(CODENAME) | tr ' ' '\n' >> $@.in
endif
	# append PGI-required extra packages, architecture-specific extra
	# packages, and user-specified extra packages
	for pkglist in $(PGI_DIR)/stage1/internal.extra_packages \
		       $(PGI_DIR)/stage1/$(ARCH)/extra_packages \
		       $(ETC_DIR)/extra_packages; do \
		if [ -f $$pkglist ]; then \
			grep -v '^[[:space:]]*#' $$pkglist >> $@.in; \
		fi; \
	done
	# Add packages not directly used by the installer but
	# which the user wants on the medium.
	if [ -f $(TASK) ]; then \
		grep -v '^[[:space:]]*#' $(TASK) >> $@.in; \
	fi
	# Done with PGI-specific stuff.
	$(Q)perl -npe 's/\@ARCH\@/$(ARCH)/g' $@.in | \
	 cpp -nostdinc -nostdinc++ -P -undef -D ARCH=$(ARCH) -D ARCH_$(ARCH) \
	     -U $(ARCH) -U i386 -U linux -U unix \
	     -DFORCENONUSONCD1=$(forcenonusoncd1) \
	     -I $(BASEDIR)/tasks -I $(BDIR) - - >> $@

## DIRECTORIES && PACKAGES && INFOS ##

# Create all the needed directories for installing packages (plus the
# .disk directory)
tree: bin-tree src-tree
bin-tree: ok bin-list $(BDIR)/CD1/debian
$(BDIR)/CD1/debian:
	@echo "Adding the required directories to the binary CDs ..."
	$(Q)set -e; \
	 for i in $(BDIR)/*.packages; do \
		dir=$${i%%.packages}; \
		dir=$${dir##$(BDIR)/}; \
		dir=$(BDIR)/CD$$dir; \
		mkdir -p $$dir; \
		$(add_dirs) $$dir; \
	done

src-tree: ok src-list $(SDIR)/CD1/debian
$(SDIR)/CD1/debian:
	@echo "Adding the required directories to the source CDs ..."
	$(Q)set -e; \
	 for i in $(SDIR)/*.sources; do \
		dir=$${i%%.sources}; \
		dir=$${dir##$(SDIR)/}; \
		dir=$(SDIR)/CD$$dir; \
		mkdir -p $$dir; \
		$(add_dirs) $$dir; \
	done

# CD labels / volume ids / disk info
infos: bin-infos src-infos
bin-infos: bin-tree $(BDIR)/CD1/.disk/info
$(BDIR)/CD1/.disk/info:
	@echo "Generating the binary CD labels and their volume ids ..."
	$(Q)set -e; \
	 nb=`ls -l $(BDIR)/?.packages | wc -l | tr -d " "`; num=0;\
	 DATE=`date +%Y%m%d`; \
	for i in $(BDIR)/*.packages; do \
		num=$${i%%.packages}; num=$${num##$(BDIR)/}; \
		dir=$(BDIR)/CD$$num; \
		echo -n $(BINDISKINFO) | sed 's/_NONUS//g' > $$dir/.disk/info; \
		echo '#define DISKNAME ' $(BINDISKINFOND) | sed 's/_NONUS//g' \
					> $$dir/README.diskdefines; \
		echo '#define TYPE  binary' \
					>> $$dir/README.diskdefines; \
		echo '#define TYPEbinary  1' \
					>> $$dir/README.diskdefines; \
		echo '#define ARCH ' $(ARCH) \
					>> $$dir/README.diskdefines; \
		echo '#define ARCH'$(ARCH) ' 1' \
					>> $$dir/README.diskdefines; \
		echo '#define DISKNUM ' $$num | sed 's/_NONUS//g' \
					>> $$dir/README.diskdefines; \
		echo '#define DISKNUM'$$num ' 1' | sed 's/_NONUS//g' \
					>> $$dir/README.diskdefines; \
		echo '#define TOTALNUM ' $$nb \
					>> $$dir/README.diskdefines; \
		echo '#define TOTALNUM'$$nb ' 1' \
					>> $$dir/README.diskdefines; \
		echo -n $(BINVOLID) > $(BDIR)/$${num}.volid; \

=== images/i386/Makefile ===
# $Progeny: Makefile,v 1.65 2002/04/22 21:15:44 branden Exp $

SHELL=	/bin/sh -e

ifdef DO_PCMCIA_ARCHIVE
PCMCIA_ARCHIVE=$(TDIR)/pcmcia.tgz
endif

# XXX: put ISOLINUX support here

SYSLINUX_CONF_FILES = syslinux.cfg
SYSLINUX_TEXT_FILES = $(TDIR)/screen01.txt \
                    $(TDIR)/screen02.txt \
                    $(TDIR)/screen03.txt \
                    $(TDIR)/screen04.txt \
                    $(TDIR)/screen05.txt \
                    $(TDIR)/screen06.txt \
                    $(TDIR)/screen07.txt \
                    $(TDIR)/screen08.txt \
                    $(TDIR)/screen09.txt \
                    $(TDIR)/screen10.txt

# initrd we're using, created by stage0
INITRD = $(TDIR)/initrd.installer.gz

# list of files to be placed on the boot media
INSTALLER_FILES = $(TDIR)/install-2.88 $(TDIR)/modules.tgz $(PCMCIA_ARCHIVE)

# directory containing $(INSTALLER_FILES) and the live filesystem
INSTALLER_FILES_FS = $(TDIR)/installer-files.fs

# What we build in this Makefile depends on our final product.
# If it's an installer-only ISO, we'll have everything we need,
# and can produce one here.  Otherwise, we'll merely generate
# files for the ISO that the archive/ directory will produce, and
# calculate the space these files will occupy, since that space
# will be unavailable for a package archive on the ISO.

ifdef INSTALLER_ONLY
# Command and options for building ISOs.
MKISOFS=/usr/bin/mkisofs
MKISOFS_OPTS=-l -r
# name of ISO image we'll be building
ISO=$(OUT)/$(CODENAME)-installer-$(ARCH).iso
else
# file containing calculated size of $(INSTALLER_FILES_FS) (see archive/Makefile)
INSTALLER_FILES_FS_SIZE = $(TDIR)/installer-files.fs.size
endif

all: $(INSTALLER_FILES_FS_SIZE) $(ISO)

# Create a 2.88 MB floppy image for El Torito bootable CD-ROMs.
$(TDIR)/install-2.88: $(TDIR)/install-2.88.empty $(INITRD) $(SYSLINUX_CONF_FILES) $(SYSLINUX_TEXT_FILES)
	@echo Creating $$(basename $@)...
	cp $(TDIR)/install-2.88.empty $@.image
	mkdir $@.mnt
	$(SU_CMD) mount -oloop -tvfat $@.image $@.mnt
	$(SU_CMD) install /boot/vmlinuz-$(KERNEL_VERSION) $@.mnt/linux || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) install $(INITRD) $@.mnt/initrd || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) install $(SYSLINUX_CONF_FILES) $(SYSLINUX_TEXT_FILES) $@.mnt || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) umount $@.mnt
	rmdir $@.mnt
	$(SU_CMD) syslinux $(SYSLINUX_OPTIONS) $@.image
	mv $@.image $@

# Create an empty 2.88 MB DOS filesystem.
$(TDIR)/install-2.88.empty:
	mkdosfs -C $@.tmp 2880 >& /dev/null
# mkdosfs makes the image executable for some silly reason
	chmod ugo-x $@.tmp
	mv $@.tmp $@

# Create a compressed archive of all kernel modules corresponding
# to the kernel being used.  This archive is not unpacked into
# the initrd; it is too large.  Instead, discover is used to
# cherry-pick required modules from it.
$(TDIR)/modules.tgz:
	tar -cf - /lib/modules/$(KERNEL_VERSION) | gzip -9 > $@.tmp
	mv $@.tmp $@

# If the kernel being used has PCMCIA support, create a compressed
# archive of corresponding PCMCIA kernel modules.  This is
# unpacked into the initrd because we can't know what PCMCIA
# modules we need without loading some of these first.
$(PCMCIA_ARCHIVE):
	tar -cf - /lib/modules/$(KERNEL_VERSION)/pcmcia | gzip -9 > $@.tmp
	mv $@.tmp $@

# Generate the information screens displayed by SYSLINUX.
$(SYSLINUX_TEXT_FILES):
	sed -e "s/@DATE@/$$(date --iso-8601=seconds --utc)/" \
	    -e "s/@BUILDER@/$(BUILDER)/" \
	    -e "s/@PGI_VERSION@/$(PGI_VERSION)/" \
	    -e "s/@VERSION@/$(VERSION)/" < $(ETC_DIR)/syslinux.$$(basename $@).in > $@.tmp
	mv $@.tmp $@

# Create a directory tree containing everything that will be
# placed on the ISO (not including package archives, which are
# generated in archive/ if required).
$(INSTALLER_FILES_FS): $(INSTALLER_FILES)
	-rm -r $@.tmp $@
	mkdir $@.tmp
	cp -a $(INSTALLER_FILES) $@.tmp
	cp -a $(TDIR)/live/* $@.tmp
	mv $@.tmp $@

# Calculate the disk consumption of the files to be placed on the
# ISO, so we know how much less room will be available on the
# (first) ISO for use by a package archive.
$(INSTALLER_FILES_FS_SIZE): $(INSTALLER_FILES_FS)
	du -bs $(INSTALLER_FILES_FS) | awk '{print $$1}' > $@.tmp
	mv $@.tmp $@

# If we're building an installer-only ISO, create it now.
$(ISO): $(INSTALLER_FILES_FS)
	@echo "Generating the installer ISO image..."
	$(MKISOFS) $(MKISOFS_OPTS) -V "$(CODENAME) Installer" \
	 -b install-2.88 -o $@.tmp $(INSTALLER_FILES_FS)
	mv --backup=numbered $@.tmp $@

clean:
	rm -rf $(SYSLINUX_TEXT_FILES) \
	    $(INSTALLER_FILES) \
	    $(INSTALLER_FILES_FS) \
	    $(INSTALLER_FILES_FS_SIZE) \
	    $(TDIR)/install-2.88.empty \
	    $(TDIR)/install-2.88.image \
	    $(TDIR)/install-2.88.mnt

distclean: clean

.PHONY: all clean distclean

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== images/ia64/Makefile ===
# $Progeny: Makefile,v 1.18 2002/04/22 21:16:12 branden Exp $

SHELL=	/bin/sh -e

# XXX: put ISOLINUX support here

# initrd we're using, created by stage0
INITRD = $(TDIR)/initrd.installer.gz

# list of files to be placed on the boot media
INSTALLER_FILES = $(TDIR)/install

# directory containing $(INSTALLER_FILES) and the live filesystem
INSTALLER_FILES_FS = $(TDIR)/installer-files.fs

# size (in kB) of the EFI filesystem we will create to house elilo, the kernel, etc.
IMAGE_SIZE = 10000

# What we build in this Makefile depends on our final product.
# If it's an installer-only ISO, we'll have everything we need,
# and can produce one here.  Otherwise, we'll merely generate
# files for the ISO that the archive/ directory will produce, and
# calculate the space these files will occupy, since that space
# will be unavailable for a package archive on the ISO.

ifdef INSTALLER_ONLY
MKISOFS=/usr/bin/mkisofs
MKISOFS_OPTS=-l -r
ISO=$(OUT)/$(CODENAME)-installer-$(ARCH).iso
else
# file containing calculated size of $(INSTALLER_FILES_FS) (see archive/Makefile)
INSTALLER_FILES_FS_SIZE = $(TDIR)/installer-files.fs.size
endif

all: $(INSTALLER_FILES_FS_SIZE) $(ISO)

# Create an EFI (VFAT) filesystem that contains elilo, the
# kernel, and the initrd; everything we need to boot.
$(TDIR)/install: $(TDIR)/install.empty $(INITRD)
	@echo Creating $$(basename $@)...
	cp $(TDIR)/install.empty $@.image
	mkdir $@.mnt
	$(SU_CMD) mount -oloop -tvfat $@.image $@.mnt
	$(SU_CMD) install /boot/vmlinuz-$(KERNEL_VERSION) $@.mnt/linux || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) install $(INITRD) $@.mnt/initrd || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	# install ELILO to the install image
	$(SU_CMD) mkdir -p $@.mnt/boot/efi || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) install /usr/lib/elilo/elilo.efi $@.mnt || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) install /usr/lib/elilo/elilo.efi $@.mnt/boot/efi/bootia64.efi || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) echo "elilo linux" > $@.mnt/install.nsh || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) install elilo.conf $@.mnt || ($(SU_CMD) umount $@.mnt; rm -rf $@.mnt; exit 1)
	$(SU_CMD) umount $@.mnt
	rmdir $@.mnt
	mv $@.image $@

# Create an empty EFI (VFAT) filesystem.
$(TDIR)/install.empty:
	mkdosfs -C $@.tmp $(IMAGE_SIZE) >& /dev/null
# mkdosfs makes the image executable for some silly reason
	chmod ugo-x $@.tmp
	mv $@.tmp $@

# Create a directory tree containing everything that will be
# placed on the ISO (not including package archives, which are
# generated in archive/ if required).
$(INSTALLER_FILES_FS): $(INSTALLER_FILES)
	-rm -r $@.tmp $@
	mkdir $@.tmp
	cp -a $(INSTALLER_FILES) $@.tmp
	cp -a $(TDIR)/live/* $@.tmp
	mv $@.tmp $@

# Calculate the disk consumption of the files to be placed on the
# ISO, so we know how much less room will be available on the
# (first) ISO for use by a package archive.
$(INSTALLER_FILES_FS_SIZE): $(INSTALLER_FILES_FS)
	du -bs $(INSTALLER_FILES_FS) | awk '{print $$1}' > $@.tmp
	mv $@.tmp $@

# If we're building an installer-only ISO, create it now.
$(ISO): $(INSTALLER_FILES_FS)
	@echo "Generating the installer ISO image..."
	$(MKISOFS) $(MKISOFS_OPTS) -V "$(CODENAME) Installer" \
	  -no-emul-boot -J -b install -o $@.tmp $(INSTALLER_FILES_FS)
	mv --backup=numbered $@.tmp $@

clean:
	rm -rf \
	    $(INSTALLER_FILES) \
	    $(INSTALLER_FILES_FS) \
	    $(INSTALLER_FILES_FS_SIZE) \
	    $(TDIR)/install.empty \
	    $(TDIR)/install.image \
	    $(TDIR)/install.mnt \

distclean: clean

.PHONY: all clean distclean

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== images/powerpc/Makefile ===
# $Progeny: Makefile,v 1.3 2002/04/22 21:18:44 branden Exp $

SHELL=	/bin/sh -e

# XXX: put ISOLINUX support here

# initrd we're using, created by stage0
INITRD = $(TDIR)/initrd.installer.gz

# list of files to be placed on the boot media
INSTALLER_FILES = $(TDIR)/install $(TDIR)/boot.msg

# directory containing $(INSTALLER_FILES) and the live filesystem
INSTALLER_FILES_FS = $(TDIR)/installer-files.fs

# size (in kB) of the filesystem we will create to house yaboot, the kernel, etc.
IMAGE_SIZE = 10000

# What we build in this Makefile depends on our final product.
# If it's an installer-only ISO, we'll have everything we need,
# and can produce one here.  Otherwise, we'll merely generate
# files for the ISO that the archive/ directory will produce, and
# calculate the space these files will occupy, since that space
# will be unavailable for a package archive on the ISO.

ifdef INSTALLER_ONLY
MKISOFS=/usr/bin/mkisofs
MKISOFS_OPTS=-l
ISO=$(OUT)/$(CODENAME)-installer-$(ARCH).iso
else
# file containing calculated size of $(INSTALLER_FILES_FS) (see archive/Makefile)
INSTALLER_FILES_FS_SIZE = $(TDIR)/installer-files.fs.size
endif

all: $(INSTALLER_FILES_FS_SIZE) $(ISO)

# Create a banner message for yaboot.
$(TDIR)/boot.msg:
	echo "PGI $(PGI_VERSION)" > $@

# Create directory that contains yaboot, the kernel, and the
# initrd; everything we need to boot.
$(TDIR)/install: $(INITRD) $(TDIR)/boot.msg
	@echo Creating $$(basename $@)...
	mkdir $@.tmp
	install /boot/vmlinuz-$(KERNEL_VERSION) $@.tmp/linux || (rm -rf $@.tmp; exit 1)
	install $(INITRD) $@.tmp/initrd || (rm -rf $@.tmp; exit 1)
	install /usr/lib/yaboot/yaboot $@.tmp || (rm -rf $@.tmp; exit 1)
	install /usr/lib/yaboot/ofboot $@.tmp/ofboot.b || (rm -rf $@.tmp; exit 1)
	install yaboot.conf $@.tmp || (rm -rf $@.tmp; exit 1)
	install boot.msg $@.tmp || (rm -rf $@.tmp; exit 1)
	install ofboot.b $@.tmp || (rm -rf $@.tmp; exit 1)
	mv $@.tmp $@

# Create a directory tree containing everything that will be
# placed on the ISO (not including package archives, which are
# generated in archive/ if required).
$(INSTALLER_FILES_FS): $(INSTALLER_FILES)
	-rm -r $@.tmp $@
	mkdir $@.tmp
	cp -a $(INSTALLER_FILES) $@.tmp
	cp -a $(TDIR)/live/* $@.tmp
	mv $@.tmp $@

# Calculate the disk consumption of the files to be placed on the
# ISO, so we know how much less room will be available on the
# (first) ISO for use by a package archive.
$(INSTALLER_FILES_FS_SIZE): $(INSTALLER_FILES_FS)
	du -bs $(INSTALLER_FILES_FS) | awk '{print $$1}' > $@.tmp
	mv $@.tmp $@

# If we're building an installer-only ISO, create it now.
$(ISO): $(INSTALLER_FILES_FS)
	@echo "Generating the installer ISO image..."
	$(MKISOFS) $(MKISOFS_OPTS) -V "$(CODENAME) Installer" \
		--netatalk -hfs -probe -part -no-desktop -map hfs.map \
		-hfs-bless $(INSTALLER_FILES_FS)/install -o $@.tmp \
		$(INSTALLER_FILES_FS)
	mv --backup=numbered $@.tmp $@

clean:
	rm -rf \
	    $(INSTALLER_FILES) \
	    $(INSTALLER_FILES_FS) \
	    $(INSTALLER_FILES_FS_SIZE) \
	    $(TDIR)/install.empty \
	    $(TDIR)/install.image \
	    $(TDIR)/install.mnt \

distclean: clean

.PHONY: all clean distclean

# vim:set ai noet sw=8 sts=8 ts=8 tw=0:

=== debian/changelog ===
pgi (0.9.6.3) unstable; urgency=high

  * High-urgency upload due to DFSG issues.
  * Preliminary PowerPC architecture support, care of Jimmy Kaplowitz.  I fixed
    some comments and added Progeny keywords but this is essentially his work.
    (branden)
  * archive/Makefile:
    - define a no-op clean rule for the sake of the pgi-build clean change
      (see below) (branden)
  * busybox.h:
    - Turn off a bunch of busybox features in the live filesystem that
      we weren't using (we're using GNU ls and GNU sed, etc.). (branden)
    - Include busybox ls and more in the initrd; they cost only 4kB and
      greatly reduce the pain and frustration of working with the installer when
      the live fs can't be found (or has been unmounted). (branden)
  * debian/postrm:
    - Added postrm script to scrub /etc/pgi directory on purge. (branden)
      (Closes: #143792)
  * debian/rules:
    - stop shipping out-of-date RELNOTES file (branden)
  * doc/guide.xml:
    - New chapter: "Determining Package Placement on the Installer Media"
      (branden)
    - Document building system's requirement of loopback filesystem support.
      (branden)
    - Document target system's requirement of RAM disk and Initial RAM disk
      support. (branden)
    - Added "Packet Socket" to name of "Berkeley packet address family", since
      the former is what Configure.help calls it, and at least one person
      expressed confusion about this. (branden)
  * examples/configlets/do-apt-cdrom:
    - Center dialogs. (branden)
    - Display error dialogs if our apt and dpkg tricks fail. (branden)
    - Exit with a status of 1 if our apt and dpkg tricks fail. (branden)
    - Call the media "discs", not "CDs".  (DVD-ROM, anyone?) (branden)
  * examples/configlets/extra_packages:
    - Install xloadimage as part of the configlets flavor. (branden)
    - Also install xfonts-{75dpi,scalable}. (branden)
  * examples/configlets/fvwm2rc:
    - Configure fvwm to decorate transient window and (hopefully) use a
      better looking default font. (branden)
    - Force the DeskTopSize to 1x1. (branden)
  * examples/configlets/options:
    - Removed.  What the configlets need is now in woody and there are
      no other differences between this and the stock options file. (branden)
  * examples/configlets/postinst.sh:
    - Ensure that /etc/configlets is a directory, and install fvwm2rc,
      root_window.png, and root_window.xbm to it. (branden)
  * examples/configlets/xinitrc:
    - Don't run gnome-tasksel if do-apt-cdrom fails. (branden)
    - Set the X cursor to the wristwatch icon when starting, and try to set
      the root window to an image, if one is available. (branden)
  * images/{i386,ia64,powerpc}:
    - Use the --backup=numbered argument to mv when putting the ISO images in
      place. (branden)
    - (i386 only) Expand @PGI_VERSION@ when processing the syslinux text
      files. (branden)
  * images/i386/syslinux.screen08.txt.in:
    - Report PGI version on syslinux screens. (branden) (Closes: #143887)
  * {options,examples/configlets/options}:
    - Define the INITRD_FS and INITRD_FS_SIZE variables here (in the "private"
      section). (branden)
  * pgi-build:
    - Document the -P | --pgi-http-proxy option in pgi-build's usage message.
      (branden)
    - Define whether or not an architecture is experimental in pgi-build.
      Ordinarily this would go in the options file, but I think the package
      maintainer should have control over whether an architecture is considered
      experimental or not. (branden)
    - Store command line in a variable for later writing to generated
      ISO images. (branden)
    - Clean using the Makefiles' clean rules instead of the rm -r approach.
      (Closes: #142705)
  * python/pgi/base.py:
    - The test described in revision 1.55 was backwards, and so wasn't
      happening.  After discussion with Eric, disabling the writing of
      sources.list in Stage 1 entirely.  Eric points out that it's a Stage 2
      job; for instance, base-config will clobber what we write no matter
      what, and configlets will have apt.conf one day soon. (branden)
    - Write trailing newlines to the initrd's /etc/fstab file. (branden)
    - When running debootstrap, delete PYTHONHOME from the environment
      altogether instead of setting it to null. (branden)
    - Force the exclusion of lilo from debootstrap's package list.  lilo is
      extremely evil and does this unconditionally in its postinst:
        /usr/sbin/liloconfig < /dev/tty
      (branden)
  * stage0/Makefile:
    - Major overhaul and cleanup.
      + Remove old, unneeded variables, ifdefs, and rules.
      + Reorder the rules to make more sense.
      + Don't overwrite modules.dep files in the building system's
        /lib/modules even though depmod's design is so brain-dead that
        it's really tempting to do so.
      + More of my $@.tmp stuff to handle cases where a target may exist
        before we're done manipulating it.  (This way, it doesn't.)
      + Make the clean rule actually do something useful.
      + Comment every rule of interest.
      + Stop defining INITRD_FS and INITRD_SIZE here, and
        s/INITRD_SIZE/INITRD_FS_SIZE/.
      (branden)
  * stage0/mkinitrd:
    - Reworked how we get kernel modules onto the initrd a little bit:
      Move the copying of kernel modules to be the very last thing we do to
      the initrd.  Use du -ks to see how much space is actually taken up on
      it.

      Then, for non-i386 architectures, subtract actual consumed space from
      the capacity of the initrd, and pass that figure to reducemodules.py.

      For SYSLINUX i386, our initrd is extremely limited in size, because we
      have to squeeze it into a 2.88 floppy image.

      Assume that gzip -9 can get us down to 60% of our original size, on
      average.  Experimentation on actual kernel modules reveals that gzip
      does a little better than this.  With all the text files on the initrd,


=== debootstrap/debian/changelog ===
debootstrap (0.1.17) unstable; urgency=high

  * Includes changes from NMUs. Thanks to Stefan Gybas and Eduard Bloch.
    (Closes: Bug#130764, Bug#135676, Bug#134306, Bug#133882, Bug#131768,
    Bug#117980, Bug#133298, Bug#130668, Bug#111175, Bug#131147, Bug#95143,
    Bug#130482)

  * Don't use PIPESTATUS to work out if wget succeeded, since that's a
    bashism and we're seriously not allowed bashisms. Duh. This should
    help with all those "Malformed release" problems. Thanks to Phil
    Blundell and Chris Tillman for spotting this. (Closes: Bug#136729)

  * Apply patch from Matt Zimmerman to get rid of some irritating warnings
    that can show up sometimes due to sed getting it's output stream closed
    on it. (Closes: Bug#131478)

  * Don't use "export foo=bar" on a single line since it's a bashism.
    (Closes: Bug#138187)

  * Made the "smallyes" usage independent of --boot-floppies. Too much
    code duplication otherwise.

  * Install ipchains on arches that have 2.2.x kernels by default, and
    iptables on arches that have 2.4.x kernels by default. Some arches
    have both. (Closes: Bug#134478)

  * Don't rm malformed Release files, rename them to something obvious
    instead so people can have a hope at seeing what's going on. (Closes:
    Bug#131756)

  * Error out on missing entries in Release files. (Closes: Bug#136886)

  * Fix basedeb creation to not bother building devices tarball. (Closes:
    Bug#137243)

  * Workaround for ldconfig no longer needed, so removed. (Closes: Bug#135819)
  * Workaround for /dev/initctl was never needed and stupid, so removed.

  * Make sure devices.tar.gz is gzip -9'ed. (Closes: Bug#136687)

  * Use any "main" components found in Release file, eg "main",
    "non-US/main", "local/main". (Closes: Bug#116801)

  * Add parted to base for ia64. (Closes: Bug#138246)

  * Moved the "successful!" message and sleep hack for boot-floppies from
    the woody script to the debootstrap script itself.

 -- Anthony Towns <aj@azure.humbug.org.au>  Thu, 14 Mar 2002 18:28:24 +1000

debootstrap (0.1.16.4) unstable; urgency=low

  * NMU, needed for boot-floppies 3.0.20
  * Added cciss and ataraid device files, closes: #135675
  * Applied the patch from Matt Zimmermann to fix --include, closes: #134306
  * Mail suppression fixed in previous release, closes: #133882

 -- Eduard Bloch <blade@debian.org>  Sun,  3 Mar 2002 12:21:19 +0100

debootstrap (0.1.16.3) unstable; urgency=low

  * non-maintainer-upload
  * require newer makedev, fixes build problems on m86k and arm
  * unsets $TMP, $TEMP and $TMPDIR in the beginning, closes: #131768, #117980
  * added gcc-2.96-base to ia64's required packages list, closes: #133298

 -- Eduard Bloch <blade@debian.org>  Tue, 12 Feb 2002 19:30:47 +0100

debootstrap (0.1.16.2) unstable; urgency=low

  * non-maintainer-upload
  * added modification suggested by Branden Robinson and Matt Kraai terminate
    cat (now tail) better, closes: #130668
  * provides options to install additional packages, or exclude some from the
    list. May be needed in boot-floppies soon. Closes: #111175, #131147
  * --verbose option, closes: #95143
  * added additional devices to the device list, especially input and usb
    needed for modern device drivers (Joysticks, USB, Scanners)
  * added pppoeconf to the packages list, better choice for DSL users
  * forced remove of dev/initctl, prevents breaking on re-installation

 -- Eduard Bloch <blade@debian.org>  Mon, 28 Jan 2002 19:14:41 +0100

debootstrap (0.1.16.1) unstable; urgency=high

  * non-maintainer upload for boot-floppies 3.0.19
  * Fixed list of base and required packages for s390
  * setup_devices(): don't fail if devices.tar.gz is not present and we
    are using devfs
  * disable handling of /dev/initctl for boot-floppies, closes: #130482

 -- Stefan Gybas <sgybas@debian.org>  Thu, 24 Jan 2002 15:17:42 +0100

debootstrap (0.1.16) unstable; urgency=low

  * Include NMUs 0.1.15.1 - .9, thanks to Adam di Carlo, Ethan Benson and
    Bdale Garbee. (Closes: Bug#113265, Bug#119314, Bug#119251)
  * Many bugs were fixed in the NMUs. Closes them properly. (Closes:
    Bug#89673, Bug#97174, Bug#99229, Bug#105980, Bug#106062, Bug#106102,
    Bug#106106, Bug#106134, Bug#106711, Bug#106877, Bug#107262,
    Bug#107404, Bug#107447, Bug#109670, Bug#110312, Bug#111001,
    Bug#111065, Bug#112778, Bug#112795, Bug#112842, Bug#113444,
    Bug#114056, Bug#114653, Bug#115467, Bug#115481, Bug#115557,
    Bug#115581, Bug#115699, Bug#116061, Bug#116424, Bug#119769,
    Bug#119947, Bug#121724, Bug#123958, Bug#125954, Bug#126018,
    Bug#126630, Bug#126799)

  * Informative error for people who type `--boot-floppies' when running
    by hand. (Closes: Bug#107548)
  * Create dev/initctl in target, and setup a cat process to dump anything
    sent to it to /dev/null so that if init is run in the chroot,
    it doesn't try doing anything too clever to talk to the real
    init. (Closes: Bug#120597)
  * Create awk symlink since base-files insists on having it available.
    (Closes: Bug#127934)

  * Use DEBOOTSTRAP_DIR to work out where /usr/lib/debootstrap is.
  * So, in theory, to create basedeb tarballs, you should be able to unpack
    the source and say:
    .
        fakeroot debian/rules binary-basedebs SUITE=woody VERSION=3.0 \
            MIRROR="http://ftp.debian.org/debian" ARCHES="i386 powerpc"
    (Closes: Bug#127546)

 -- Anthony Towns <aj@azure.humbug.org.au>  Sun, 20 Jan 2002 21:04:37 +1000

debootstrap (0.1.15.9) unstable; urgency=high

  * non-maintainer upload
  * debian/rules: new 'basedebs' target that makes basedebs.tgz and 1.44
    split images for base per arch
  * functions: better return value handling during wget (wgetprogress)
  * repeat() had a useless eval, removed, which simplifies some silly
    quoting
  * incorrect error message in in_target_msg(), closes: #119769
  * debian/changelog: remove obsolete "local variables"


=== debian/control ===
Source: pgi
Section: admin
Priority: extra
Maintainer: Progeny Debian Packaging Team <debian-packages@progeny.com>
Build-Depends: debhelper (>= 3.0.0), docbook-xml, docbook-dsssl, docbook-to-man, jade, opensp, html2text, links
Standards-Version: 3.5.6

Package: pgi
Architecture: i386 ia64 powerpc
Depends: build-essential, busybox-source-0.60.0, libc6-pic | glibc-pic, libdigest-md5-perl, debootstrap (>= 0.1.17), makedev (>= 2.3.1-58), mkisofs, modutils, sudo, ash, discover (>> 1.0), discover-data (>= 1.2002.03.19), net-tools, udhcpc, binutils, curl, dialog, dnsutils, dosfstools (>= 2.8-1), dpkg (>= 1.9.19), etherconf (>= 1.7), fdutils, file, gawk, gnupg, gtk-engines-raleigh, host | bind9-host, less, lynx, mdetect, mtools, netcat, nvi, parted, patch, pciutils, netkit-ping | ping, procps, psmisc, rcs, rxvt (>= 1:2.6.4-2), ssh, strace, traceroute, wget, xbase-clients, xserver-xfree86, xfonts-base, xfonts-100dpi, xloadimage, xterm, python2.1, python-glade, python-gnome, python-parted (>> 0.10), ${F:Arch-Depends}
Recommends: kernel-image-2.2.20 | kernel-image, pcmcia-modules-2.2.20 | pcmcia-modules, pcmcia-cs
Description: Progeny graphical installer creation system
 This package contains PGI, a multi-architecture graphical installer creation
 system for Debian GNU/Linux originally developed by Progeny Linux Systems,
 Inc., for their Debian-based "Progeny Debian" operating system.
 .
 This package enables the user to create ISO images containing a bootable
 installer (PGI) which guides the user through the steps of installation.  The
 installer supports text and graphical installation modes.  PGI runs
 debootstrap to install a minimal Debian system to the target filesystem(s),
 sets up a boot loader (if the installing user requests), and uses the
 pivot_root() system call to "boot" into the installed system.  ISO images may
 be generated with complete or partial Debian package archives, or with the
 the installer only (useful for network-only installs, which PGI supports.)
 .
 PGI is extensible and customizable.  Two example extensions are provided with
 this package; one uses the base-config package, while the other configures
 the installed system using the X-based Configlet system.
 .
 Two manuals are provided as part of this package.  "Creating Debian
 Installers with PGI" documents the setup and configuration of a PGI-based
 installer ISO in detail.  "Using the PGI Debian Installer" is an example of a
 PGI user's manual.  Those creating custom installers with PGI will want to
 update the user's manual for their target audience.

=== debootstrap/debian/control ===
Source: debootstrap
Section: admin
Priority: extra
Maintainer: Anthony Towns <ajt@debian.org>
Build-Depends: debhelper (>> 2.0.0), makedev (>= 2.3.1-58)
Standards-Version: 3.2.1

Package: debootstrap
Architecture: any
Depends: ${shlibs:Depends}, wget
Description: Bootstrap a basic Debian system
 debootstrap is used to create a Debian base system from scratch,
 without requiring the availability of dpkg or apt. It does this by
 downloading .deb files from a mirror site, and carefully unpacking them
 into a directory which can eventually be chrooted into.

=== debian/rules ===
#!/usr/bin/make -f
# Debian package build rules file for pgi
# Copyright 1997-1999 Joey Hess.
# Copyright 2001 Software in the Public Interest, Inc.
# Copyright 2002 Progeny Linux Systems, Inc.
# Licensed under the GNU General Public License, version 2.  See the file
# /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.

# $Progeny: rules,v 1.12 2002/04/19 16:29:20 branden Exp $

BUILD_ARCH:=$(shell dpkg --print-architecture)
ifdef DEB_HOST_ARCH
 ARCH:=$(DEB_HOST_ARCH)
else
 # dpkg-cross sets the ARCH environment variable, so use it.
 ifdef ARCH
  ARCH:=$(ARCH)
 else
  ARCH:=$(BUILD_ARCH)
 endif
endif

I386_DEPS="syslinux (>= 1.63-1), read-edid"
IA64_DEPS="elilo, efibootmgr"
POWERPC_DEPS="yaboot, powerpc-utils"

# *sigh* Make has nothing approaching switch/case, not even elif
ifeq ($(ARCH),i386)
  ARCH_DEPS=$(I386_DEPS)
endif

ifeq ($(ARCH),ia64)
 ARCH_DEPS=$(IA64_DEPS)
endif

ifeq ($(ARCH),powerpc)
  ARCH_DEPS=$(POWERPC_DEPS)
endif

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=2

build: build-stamp
build-stamp:
	dh_testdir
#	nothing to do
	touch build-stamp

clean: Makefile
	dh_testdir
	dh_testroot
	rm -f build-stamp

#	nothing to do

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) DESTDIR=$(CURDIR)/debian/pgi install-pgi

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installmenu
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol -- -VF:Arch-Depends=$(ARCH_DEPS)
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debootstrap/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=2

configure:
	dh_testdir

clean:
	dh_testdir

	-$(MAKE) clean

	dh_clean

build: configure
#	 need to be root to make devices, so build is done in install target

real-build: build
	dh_testdir
	dh_testroot

	$(MAKE) all

install: real-build
	dh_testdir
	dh_testroot

	dh_clean -k
	dh_installdirs

#	 install the package into debian/debootstrap
	$(MAKE) install DESTDIR=$(CURDIR)/debian/debootstrap


binary-indep: install
# We have nothing to do by default.

ARCHES="i386"
SUITE="testing"
VERSION=$(SUITE)
MIRROR="http://ftp.debian.org/debian"

binary-basedebs:
	dh_testdir
	dh_testroot

	$(MAKE) pkgdetails

	ln -s . scripts
	for a in $(ARCHES); do \
	    rm -rf chroot-dir; \
	    mkdir -p chroot-dir; \
	    DEBOOTSTRAP_DIR=. ./debootstrap --arch $$a --download-only $(SUITE) chroot-dir $(MIRROR); \
	    (cd chroot-dir && tar cf ../../basedebs_$(VERSION)_$$a.tar *); \
	    rm -rf chroot-dir; \
	done
	rm -f scripts

binary-arch: install
	dh_testdir
	dh_testroot
#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
	dh_installcron
	dh_installmanpages
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build real-build clean binary-indep binary-arch binary install configure binary-basedebs
